//====================================================================================
//  :    TouchPanel.c
//:    
//====================================================================================

#include "def.h"
#include "2440lib.h"
#include "2440addr.h"
#include "option.h"
#include "uart.h"
#include "TFT_API.h"
#include "TouchPanel.h"

short LeftBound    = TOUCH_DEFAULT_LB;			// ԵӦADתֵ(16bit)
short RightBound   = TOUCH_DEFAULT_RB;			// ұԵӦADתֵ(16bit)
short TopBound     = TOUCH_DEFAULT_TB;			// ϱԵӦADתֵ(16bit)
short BottomBound  = TOUCH_DEFAULT_BB;			// ±ԵӦADתֵ(16bit)

unsigned int TempADCx;  //ADתԭʼֵX
unsigned int TempADCy;  //ADתԭʼֵY
short ResultX;   //ʵֵX
short ResultY;   //ʵֵY

void __irq Adc_or_TsSep(void);

//=============================================================
//﷨ʽvoid Touch_Init(void)
//ʵֹܣʼʼADCIOȣADCж
//	
//ֵ	
//=============================================================
void Touch_Init(void)
{
	TempADCx = 0;
	TempADCy = 0;
	ResultX = -1;
	ResultY = -1;
		
	rADCDLY = (50000);  // ADC Start or Interval Delay
    rADCCON = (1<<14)|(39<<6)|(0<<3)|(0<<2)|(0<<1)|(0);
    // Enable Prescaler,Prescaler,AIN7/5 fix,Normal,Disable read start,No operation
    rADCTSC = (0<<8)|(1<<7)|(1<<6)|(0<<5)|(1<<4)|(0<<3)|(0<<2)|(3);
    // Down,YM:GND,YP:AIN5,XM:Hi-z,XP:AIN7,XP pullup En,Normal,Waiting for interrupt mode
  
    if(rSRCPND &BIT_ADC)
		rSRCPND |= BIT_ADC;
    if(rINTPND & BIT_ADC)
		rINTPND |= BIT_ADC;
    if(rSUBSRCPND & BIT_SUB_TC)
		rSUBSRCPND|= BIT_SUB_TC;
    if(rSUBSRCPND & BIT_SUB_ADC)
		rSUBSRCPND |= BIT_SUB_ADC;
		
    rINTMSK &=~(BIT_ADC);
    rINTSUBMSK &=~(BIT_SUB_TC);
    pISR_ADC   = (unsigned)Adc_or_TsSep;	
}

//=============================================================
//﷨ʽvoid Touch_SetBound(unsigned short left, unsigned short right, unsigned short top, unsigned short bottom);
//ʵֹܣĸԵӦADתֵڴУ׼
//	left:	ԵӦADתֵ(16bit)
//			right:	ұԵӦADתֵ(16bit)
//			top:	ϱԵӦADתֵ(16bit)
//			bottom:	±ԵӦADתֵ(16bit)
//ֵ	
//=============================================================
void Touch_SetBound(unsigned short left, unsigned short right, unsigned short top, unsigned short bottom)
{
	LeftBound = left;
	RightBound = right;
	TopBound = top;
	BottomBound = bottom;
}

//=============================================================
//﷨ʽvoid __irq Adc_or_TsSep(void);
//ʵֹܣTCжϷӳ
//	
//ֵ	
//=============================================================
void __irq Adc_or_TsSep(void)
{
	unsigned int i;
	U32 PtX[6], PtY[6];
	short TempX, TempY;
	static count = 0;

	if(rADCDAT0&0x8000)
	{
		Uart_Printf("\nStylus Up!!\n");
		rADCTSC&=0xff;	// Set stylus down interrupt bit
	}
	else 
		Uart_Printf("\nStylus Down!!\n");

	rADCTSC=(1<<3)|(1<<2);         //Pull-up disable, Seq. X,Y postion measure.
	rADCCON|=0x1;                   //start ADC

	for (i = 0; i < 5; i++)
	{
		while(rADCCON & 0x1);		    //check if Enable_start is low
		while(!(rADCCON & 0x8000));     //check if EC(End of Conversion) flag is high, This line is necessary~!!		
		while(!(rSRCPND & (BIT_ADC)));  //check if ADC is finished with interrupt bit

		PtX[i]=(rADCDAT0&0x3ff);
	 	PtY[i]=(rADCDAT1&0x3ff);
	}
	
	PtX[5]=(PtX[0]+PtX[1]+PtX[2]+PtX[3]+PtX[4])/5;
	PtY[5]=(PtY[0]+PtY[1]+PtY[2]+PtY[3]+PtY[4])/5;
	TempADCx = PtX[5];
	TempADCy = PtY[5];
	
	//check Stylus Up Interrupt.
	rSUBSRCPND|=BIT_SUB_TC;
	ClearPending(BIT_ADC);
	rINTSUBMSK=~(BIT_SUB_TC);
	rINTMSK=~(BIT_ADC);
			 
	rADCTSC =0xd3;    //Waiting for interrupt
	rADCTSC=rADCTSC|(1<<8); // Detect stylus up interrupt signal.

	while(1)  //to check Pen-up state
	{
		if(rSUBSRCPND & (BIT_SUB_TC))	//check if ADC is finished with interrupt bit
		{
			//Uart_Printf("Stylus Up Interrupt~!\n");
			break;	//if Stylus is up(1) state
		}
	}

	Uart_Printf("count=%03d  XP=%04d, YP=%04d\n", count++, TempADCx, TempADCy);    //X-position Conversion data            

	rADCTSC=rADCTSC&~(1<<8); // Detect stylus Down interrupt signal.
	rSUBSRCPND|=BIT_SUB_TC;
	rINTSUBMSK=~(BIT_SUB_TC);	// Unmask sub interrupt (TC)     
	ClearPending(BIT_ADC);
	
	TempX = TOUCH_HEIGHT * (TempADCx - TOUCH_DEFAULT_TB) / (TOUCH_DEFAULT_BB - TOUCH_DEFAULT_TB); 
	TempY = TOUCH_WIDTH * (TempADCy - TOUCH_DEFAULT_LB) / (TOUCH_DEFAULT_RB - TOUCH_DEFAULT_LB);	
	 
	ResultX = (TempX);		// 
	ResultY = (TempY);
}

//=============================================================
//﷨ʽshort Touch_Get(short *x, short *y);
//ʵֹܣȡ꺯
//	*x: ĺ; *y: 
//ֵ	
//=============================================================
short Touch_Get(short *x, short *y)
{
    if(ResultX != -1)
    {
        *x = ResultX;
        *y = ResultY;
        
        ResultX = -1;
        ResultY = -1;
        
        return 0;
    }
    else
    {
        *x = -1;
        *y = -1;
        return -1;
    }
}

void Test_TouchPanel(void)
{
    short X_Position[1],Y_Position[1];			// 淵صĴλ
	short x,y;	
	
	TFT_Init();
	LCD_Backlight(80);
 	Touch_Init();
	TFT_SetColor(COLOR_BLACK);
	
	while(Uart_GetKey() != ESC_KEY)
	{
		if(Touch_Get(X_Position,Y_Position)!=-1)  // ȡTouch Panel
		{
			x = X_Position[0];					  // дʵУX/Y
			y = TOUCH_WIDTH - Y_Position[0];
	
			TFT_Circle(y,x,5,COLOR_WHITE,PAINT_SOLID);  // ʾԲ		
			//Uart_Printf("x=%d, y=%d\n",x,y);
		}	
	}
	Uart_Printf("Test End!\n");
}

