#ifndef _TFT_DRIVER_H_
#define _TFT_DRIVER_H_

#include "TFT_Config.h"

#define MVAL		(13)
#define MVAL_USED 	(0)		//0=each frame   1=rate by MVAL
#define INVVDEN		(1)		//0=normal       1=inverted
#define BSWP		(0)		//Byte swap control
#define HWSWP		(1)		//Half word swap control

#define M5D(n) ((n) & 0x1fffff)	// To get lower 21bits

#if (LCD_TYPE == LCD_043_480272)
	#define   LCD_XSIZE_TFT   480
	#define   LCD_YSIZE_TFT   272
	
	#define VBPD		(12)	//ֱͬźŵĺ
	#define VFPD		(4)	    //ֱͬźŵǰ
	#define VSPW		(10)		//ֱͬźŵ

	#define HBPD		(43)	//ˮƽͬźŵĺ
	#define HFPD		(8)	//ˮƽͬźŵǰ
	#define HSPW		(1)	//ˮƽͬźŵ
	
	#define CLKVAL_TFT	4
	
#elif (LCD_TYPE == LCD_A70_800480)
	#define   LCD_XSIZE_TFT   800
	#define   LCD_YSIZE_TFT   480
	
	#define VBPD		(18)	//ֱͬźŵĺ
	#define VFPD		(27)	    //ֱͬźŵǰ
	#define VSPW		(2)		//ֱͬźŵ

	#define HBPD		(21)	//ˮƽͬźŵĺ
	#define HFPD		(81)	//ˮƽͬźŵǰ
	#define HSPW		(60)	//ˮƽͬźŵ
	
	#define CLKVAL_TFT	7
	
#endif

#define SCR_XSIZE_TFT 	(LCD_XSIZE_TFT)
#define SCR_YSIZE_TFT 	(LCD_YSIZE_TFT)

#if TFT_COLOR_RESV
	#define 	COLOR_WHITE		0x0000
	#define		COLOR_BLACK		0xFFFF
	#define		COLOR_RED		0x07FF
	#define		COLOR_GREEN		0xF81F
	#define		COLOR_BLUE		0xFFE0
	#define		COLOR_MAGENTA	0x07E0
	#define		COLOR_CYAN		0xF810
	#define		COLOR_YELLOW	0x001F
#else
	#define 	COLOR_WHITE		0xFFFF
	#define		COLOR_BLACK		0x0000
	#define		COLOR_RED		0xF800
	#define		COLOR_GREEN		0x07E0
	#define		COLOR_BLUE		0x001F
	#define		COLOR_MAGENTA	0xF81F
	#define		COLOR_CYAN		0x07FF
	#define		COLOR_YELLOW	0xFFE0
#endif

void TFT_InitHardware(void);
void Lcd_PowerEnable(int invpwren,int pwren);
void Lcd_EnvidOnOff(int onoff);

#endif
